//---------------------------------------------------------------------------
#include "CGIParse.h"
#include <stdio.h>

#ifndef _WIN32

#include <unistd.h>
// get_socket includes
#include <sys/socket.h>
//#include <sys/ioctl.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#else

#include <iostream>

#endif

#include <fstream>

using namespace std;

//---------------------------------------------------------------------------
// code to establish a socket; originally from bzs@bu-cs.bu.edu
int ConnectToHost(char *pHost, unsigned short portnum)
{
  int    s = -1;
  struct sockaddr_in sa;
  memset(&sa, 0, sizeof(struct sockaddr_in)); /* clear our address */

  struct hostent *hp = gethostbyname(pHost); /* get our address info */
  if (hp == NULL)                             /* we don't exist !? */
  {
    //Memo1->Lines->Add("Error in gethostbyname: " + (AnsiString)_sys_errlist[errno]);
    return(-1);
  }

  //Memo1->Lines->Add("IP Addresses used on this PC");

  //for(int i = 0; hp->h_addr_list[i] != NULL; i++)
  //{
    // inet_ntoa converts the ints to a string also.
    //Memo1->Lines->Add("Your IP address's: [" + IntToStr((int)(unsigned char)hp->h_addr_list[i][0]) +
    //                  "." + IntToStr((int)(unsigned char)hp->h_addr_list[i][1]) +
    //                  "." + IntToStr((int)(unsigned char)hp->h_addr_list[i][2]) +
    //                  "." + IntToStr((int)(unsigned char)hp->h_addr_list[i][3]));
  //}

  sa.sin_family = AF_INET;              /* this is our host address */
  memcpy(&sa.sin_addr, hp->h_addr, hp->h_length);
  //sa.sin_addr = *((LPIN_ADDR)*hp->h_addr_list);              /* this is our host address */
  sa.sin_port = htons(portnum);                /* this is our port number */

  if ((s = socket(PF_INET, SOCK_STREAM, 0)) < 0) /* create socket */
  {
    //Memo1->Lines->Add("Error in socket: " + (AnsiString)_sys_errlist[errno]);
    return(-1);
  }

  //int iRet = 0;
  if(connect(s,(struct sockaddr *)&sa,sizeof(sa)) < 0)
  {
    //Memo1->Lines->Add("Error in connect: " + (AnsiString)_sys_errlist[errno]);
    return(-1);
  }

  return(s);
}
//---------------------------------------------------------------------------

int main(int argc, char* argv[])
{

#ifdef _WIN32
    auto_ptr<WSADATA> lpwsaData_m;
    // This section for Winsock
    WORD wVersionRequested = MAKEWORD(1, 1);
    lpwsaData_m.reset(new WSADATA);
#endif

  string sLogFile = "paypalcid.log";
  ofstream oLog;

  try
  {
    CGIparse p;
    p.printMime();

    #ifdef _WIN32
    oLog.open(sLogFile.c_str(),std::ios_base::app);
    #else
    oLog.open(sLogFile.c_str(),ios::app);
    #endif

#ifdef _WIN32
    int nResult = WSAStartup(wVersionRequested, lpwsaData_m.get());
    if (nResult != 0)
    {
      throw "Problem Initializing Winsock!";
    }

    if (LOBYTE(lpwsaData_m->wVersion) != 1 || HIBYTE(lpwsaData_m->wVersion) != 1)
    {
      throw "Problem with Winsock Version.";
    }
#endif

    string s1  = (p.valueOf("receiver_email") ? p.valueOf("receiver_email") : "");
    string s2  = (p.valueOf("item_name") ? p.valueOf("item_name") : "");
    string s3  = (p.valueOf("item_number") ? p.valueOf("item_number") : "");
    string s4  = (p.valueOf("quantity") ? p.valueOf("quantity") : "");
    string s5  = (p.valueOf("invoice") ? p.valueOf("invoice") : "");
    string s6  = (p.valueOf("custom") ? p.valueOf("custom") : "");
    string s7  = (p.valueOf("payment_status") ? p.valueOf("payment_status") : "");
    string s8  = (p.valueOf("pending_reason") ? p.valueOf("pending_reason") : "");
    string s9  = (p.valueOf("payment_date") ? p.valueOf("payment_date") : "");
    string s10 = (p.valueOf("payment_gross") ? p.valueOf("payment_gross") : "");
    string s11 = (p.valueOf("payment_fee") ? p.valueOf("payment_fee") : "");
    string s12 = (p.valueOf("txn_id") ? p.valueOf("txn_id") : "");
    string s13 = (p.valueOf("txn_type") ? p.valueOf("txn_type") : "");
    string s14 = (p.valueOf("first_name") ? p.valueOf("first_name") : "");
    string s15 = (p.valueOf("last_name") ? p.valueOf("last_name") : "");
    string s16 = (p.valueOf("address_street") ? p.valueOf("address_street") : "");
    string s17 = (p.valueOf("address_city") ? p.valueOf("address_city") : "");
    string s18 = (p.valueOf("address_state") ? p.valueOf("address_state") : "");
    string s19 = (p.valueOf("address_zip") ? p.valueOf("address_zip") : "");
    string s20 = (p.valueOf("address_country") ? p.valueOf("address_country") : "");
    string s21 = (p.valueOf("address_status") ? p.valueOf("address_status") : "");
    string s22 = (p.valueOf("payer_email") ? p.valueOf("payer_email") : "");
    string s23 = (p.valueOf("payer_status") ? p.valueOf("payer_status") : "");
    string s24 = (p.valueOf("payment_type") ? p.valueOf("payment_type") : "");
    string s25 = (p.valueOf("notify_version") ? p.valueOf("notify_version") : "");
    string s26 = (p.valueOf("verify_sign") ? p.valueOf("verify_sign") : "");
    //string s27 = (p.valueOf("invoice") ? p.valueOf("invoice") : "");

    oLog << "Building handshake to send to paypal..." << endl;
    oLog.flush();

    string sReq = "cmd=_notify-validate";

    const CGIparse::node* itr = p.getHead();
    while(itr != NULL)
    {
      sReq += (string)"&" + (string)itr->getKey() + (string)"=" + (string)p.urlencode(itr->getValue());
      itr = itr->getLink();
    }

    char szContentLen[40]="";
    sprintf(szContentLen,"%d",sReq.length());

    string sHeader = "";
    // post back to PayPal system to validate
    sHeader += "POST /cgi-bin/webscr HTTP/1.0\r\n";
    sHeader += "Content-Type: application/x-www-form-urlencoded\r\n";
    sHeader += (string)"Content-Length: " + szContentLen + (string)"\r\n\r\n";
    sHeader += sReq;

    oLog << "About to send handshake to paypal: Len: " << sHeader.length() << " data [" << sHeader << "]" << endl;
    oLog.flush();

    bool bFound = false;
    int fp = ConnectToHost("www.paypal.com", 80);
    if (fp <= 0)
    {
      // HTTP ERROR
      oLog << "ERROR opening payplay connection!" << endl;
      oLog.flush();
    }
    else
    {
      oLog << "SUCCESS opening payplay connection!" << endl;
      oLog.flush();

      int iBytes = send(fp, sHeader.c_str(),sHeader.length(),0);
      if(iBytes > 0)
      {
        char szBuf[1024]="";
        while((iBytes = recv(fp,szBuf,1024,0)) > 0)
        {
          oLog << "Handshake from paypal: [" << szBuf << "]" << endl;
          oLog.flush();

          string sRes = szBuf;
          int iPos = sRes.find("VERIFIED");
          if(iPos >= 0 && iPos < sRes.length())
          {
            // check the payment_status=Completed
            // check that txn_id has not been previously processed
            // check that receiver_email is an email address in your PayPal account
            // process payment
            oLog << "Paypal Transaction verified!" << endl;
            oLog.flush();

            bFound = true;

            // Do special processing here
            //!!!
          }
          else
          {
            iPos = sRes.find("INVALID");
            if(iPos >= 0 && iPos < sRes.length())
            {
              // log for manual investigation
              // possible hack attempt???
              oLog << "Paypal Transaction FAILED!" << endl;
              oLog.flush();

              bFound = true;

              // An Error Occurred
              // !!!
            }
          }
        }
      }
      else
      {
        oLog << "Error sending handshake to paypal!" << endl;
        oLog.flush();
      }

      if(bFound == false)
      {
        oLog << "NO Valid response from paypal!" << endl;
        oLog.flush();
      }

      oLog << "Closing connection to paypal!" << endl;
      oLog.flush();

      #ifndef _WIN32
      close(fp);
      #else
      closesocket(fp);
      #endif
    }

    //p.formDump();
    //cout.flush();
  }
  catch(const char *ex)
  {
    if(oLog.is_open())
    {
      oLog << "Internal error detected: " << ex << endl;
      oLog.flush();
    }
    cout << "Internal error detected: " << ex << endl;
    cout.flush();
  }
  //catch(const exception &ex)
  //{
  //  cout << "Internal error detected: " << ex.what() << endl;
  //  cout.flush();
  //}
  catch(...)
  {
    if(oLog.is_open())
    {
      oLog << "UNKNOWN Internal error detected!" << endl;
      oLog.flush();
    }

    cout << "UNKNOWN Internal error detected!" << endl;
    cout.flush();
  }

  if(oLog.is_open())
  {
    oLog.close();
  }

#ifdef _WIN32
WSACleanup();
#endif

  return 0;
}

//---------------------------------------------------------------------------
